/*
 * Copyright 2007 Gabe Dijkstra and Robert Hensing
 *
 * This file is part of the Huygens Raytracer.
 * The Huygens Raytracer is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2, or
 * (at your option) any later version.
 *
 * The Huygens Raytracer is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * The GNU General Public License can be found in a file called LICENSE
 * in the directory where this file resides. It is also available at
 * http://www.gnu.org/licenses/
 *
 */

#include "Math.h"
#include <string.h>

void
Matrix3::normalize () {
  x.normalize();
  y.normalize();
  z.normalize();
}

Matrix3::Matrix3 () :
  x(1.0f, 0.0f, 0.0f),
  y(0.0f, 1.0f, 0.0f),
  z(0.0f, 0.0f, 1.0f) { }

float
getAngleFactor(const char *input_name) {
#define A(name, value) \
  if (strcasecmp(input_name, name) == 0) {	\
    return value;				\
  }						\

  A("rad", 1.0f);
  A("deg", 0.017453292519943295f);
  A("degree", 0.017453292519943295f);
  A("pie", 6.2831853071795862f);
  A("pi", 3.1415926535897931f);
#undef A
  throw (void *)NULL;
}
