/*
 * Copyright 2007 Gabe Dijkstra and Robert Hensing
 *
 * This file is part of the Huygens Raytracer.
 * The Huygens Raytracer is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2, or
 * (at your option) any later version.
 *
 * The Huygens Raytracer is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * The GNU General Public License can be found in a file called LICENSE
 * in the directory where this file resides. It is also available at
 * http://www.gnu.org/licenses/
 *
 */

#ifndef Object_h
#define Object_h

class Color;
class Ray;
class Scene;

class Object {
protected:
  Scene *scene;

public:
  float diffuse_coeff;
  float specular_coeff;
  float reflectivity;
  float shininess;
  float emittance;

  virtual ~Object() {};
  
  virtual float intersect (Ray ray) = 0;
  virtual Color reflect(Ray ray, float t, int recur_depth) = 0;
  
  void setScene (Scene *);
};

#endif
