/*
 * Copyright 2007 Gabe Dijkstra and Robert Hensing
 *
 * This file is part of the Huygens Raytracer.
 * The Huygens Raytracer is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2, or
 * (at your option) any later version.
 *
 * The Huygens Raytracer is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * The GNU General Public License can be found in a file called LICENSE
 * in the directory where this file resides. It is also available at
 * http://www.gnu.org/licenses/
 *
 */

#ifndef Sphere_h
#define Sphere_h

#include "Color.h"
#include "Object.h"
#include "Math.h"

class Sphere : public Object {
  Vector position;
  float radius;
  Color color;
  
public:
  Sphere(void);
  Sphere(Vector pos, float r);
  Sphere(Vector pos, float r, Color c);
  Sphere(const char *desc);

  float intersect (Ray);
  Color reflect (Ray, float t, int recur_depth);
};

#endif
